/**********************************************************************
File Name:           twitter.c
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                   http://www.areasx.com

Versione:             0.0
Data:                   15/09/11
Note Hardware:
Note Software:
**********************************************************************/
#class auto

#define TCPCONFIG             0
#define USE_ETHERNET          1
#define MY_IP_ADDRESS        "192.168.9.135"
#define MY_GATEWAY           "192.168.9.1"
#define MY_NAMESERVER        "212.216.112.112"

#define TCP_BUF_SIZE    1024
#define MAX_TCP_SOCKET_BUFFERS 4


#define TWITTER_STATUS "E da oggi anche il Rabbit Twitta ;)"
#define TWITTER_TOKEN  "318938137-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"

#define TWITTER_APP_SRV   "www.desantix.it"
#define TWITTER_APP_PATH  "/twitter/twitthttp/"


#define LED1_ON       BitWrPortI(PBDR, &PBDRShadow, 1, 2);
#define LED1_OFF      BitWrPortI(PBDR, &PBDRShadow, 0, 2);
#define BUTTON_PRESS  (BitRdPortI(PBDR,0)==1)


#memmap xmem
#use "dcrtcp.lib"

void BoardInit() {

  // Inizializzazione port PB0 in ingresso (pulsante)
  BitWrPortI(PBDDR, &PBDDRShadow, 0,0);

  // Inizializzazione port PB2 (Led 1)
  BitWrPortI(PBDDR, &PBDDRShadow, 1,2);

}


cofunc int Twitter(char* TwitterStatus, char* TwitterToken ){
  auto longword       DestIP;
  auto unsigned long  T0;
  auto tcp_Socket     TcpID;
  auto char           Buffer[255];
  auto char           TmpBuffer[255];
  auto int            RxChar;
  auto char           Ret;

  Ret       = 0;
  Buffer[0] = 0;
  if(0L == (DestIP = resolve(TWITTER_APP_SRV))) Ret=10;;
  if(Ret==0) {
    T0=MS_TIMER;
    tcp_open(&TcpID,0,DestIP,80,NULL);
    while(!sock_established(&TcpID)) { //Attende la connessione con il server
      if (T0>MS_TIMER) T0=MS_TIMER;
      if (MS_TIMER>(30000)+T0) {
        Ret=10;
        break;
      }
      yield;
    }
  }
  if(Ret==0) {
    sprintf(TmpBuffer, "status=%s&token=%s",TwitterStatus,TwitterToken);
    sprintf(Buffer, "POST %s HTTP/1.1\r\nHost: %s\r\nUser-Agent: Mozilla/4.0\r\nContent-Length: %d\r\nContent-Type: application/x-www-form-urlencoded\r\n\r\n", TWITTER_APP_PATH, TWITTER_APP_SRV,(int)strlen(TmpBuffer));
    sock_write(&TcpID, Buffer, (int)strlen(Buffer));
    sock_flushnext(&TcpID);
    sock_write(&TcpID, TmpBuffer, (int)strlen(TmpBuffer));
    sock_flushnext(&TcpID);
    sock_write(&TcpID, "\r\n", 2);
    sock_flushnext(&TcpID);
    //Scarico la risposta dal web server
    Buffer[0]=0;
    T0=MS_TIMER;
    do {
      if (T0>MS_TIMER) T0=MS_TIMER;     // Wrap Around timer
      if (MS_TIMER>(30000)+T0) break;   //Uscita per timeout
      RxChar = sock_bytesready(&TcpID);
      if(RxChar>0){
        TmpBuffer[0]=0;
        if (RxChar > sizeof(TmpBuffer) - 1) RxChar = sizeof(TmpBuffer) - 1;
        RxChar = sock_fastread(&TcpID,TmpBuffer,RxChar);
        TmpBuffer[RxChar] = '\0';
        if((RxChar + strlen(Buffer))>sizeof(Buffer)) break;
        strcat(Buffer, TmpBuffer);
      } else if (RxChar==-1) yield;
    } while(tcp_tick(&TcpID));
    sock_close(&TcpID);
    T0=MS_TIMER;
    do {
      if (T0>MS_TIMER) T0=MS_TIMER;     // Wrap Around timer
      if (MS_TIMER>(30000)+T0) {
        sock_abort(&TcpID);
        break; //Uscita per timeout
      }
    } while(tcp_tick(&TcpID));
  }
  if(strlen(Buffer)>0){
    if ( strstr(Buffer,"TX OK")!=NULL )
      Ret = 0;
    else {
      if (strstr(Buffer,"ERROR 1")!=NULL )     Ret = 1;
      else if (strstr(Buffer,"ERROR 2")!=NULL) Ret = 2;
      else if (strstr(Buffer,"ERROR 3")!=NULL) Ret = 3;
      else if (strstr(Buffer,"ERROR 4")!=NULL) Ret = 4;
    }
  }
  return (Ret);
}



/////////////////////
//MAIN PROGRAM
/////////////////////
void main(void) {
  int res;
  BoardInit();
  printf("Test Twitter\n");
  sock_init();
  while(1){
    costate{
      if (BUTTON_PRESS) {
          printf("Trasmetto un Twitter!!\r",res);
          LED1_ON
          wfd res = Twitter(TWITTER_STATUS, TWITTER_TOKEN);
          LED1_OFF
      
          if(res==0) 
            printf("Il Rabbit ha Twittato!\r",res);
          else
            printf("ERRORE CODICE %d\r",res);
          waitfor(IntervalSec(5));
      } else
        waitfor(IntervalSec(1));
    }
    tcp_tick( NULL );
  }
}